package xyz.brassgoggledcoders.moarcarts.renderers;

import net.minecraft.block.state.IBlockState;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.entity.RenderMinecart;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntityRendererDispatcher;
import net.minecraft.util.MathHelper;
import net.minecraft.util.Vec3;
import net.minecraftforge.fml.client.registry.IRenderFactory;
import xyz.brassgoggledcoders.moarcarts.entities.EntityMinecartTEBase;

/**
 * @author SkySom
 */
public class RenderMinecartTEBase<EM extends EntityMinecartTEBase> extends RenderMinecart<EntityMinecartTEBase>
{
	public enum Factory implements IRenderFactory<EntityMinecartTEBase>
	{
		INSTANCE;

		@Override
		@SuppressWarnings("unchecked")
		public Render<? super EntityMinecartTEBase> createRenderFor(RenderManager manager) {
			return new RenderMinecartTEBase(manager);
		}
	}

	public RenderMinecartTEBase(RenderManager renderManager)
	{
		super(renderManager);
	}

	@Override
	public void func_76986_a(EntityMinecartTEBase entity, double x, double y, double z, float entityYaw, float partialTicks)
	{
		GlStateManager.func_179094_E();
		this.func_180548_c(entity);
		long i = (long)entity.func_145782_y() * 493286711L;
		i = i * i * 4392167121L + i * 98761L;
		float f = (((float)(i >> 16 & 7L) + 0.5F) / 8.0F - 0.5F) * 0.004F;
		float f1 = (((float)(i >> 20 & 7L) + 0.5F) / 8.0F - 0.5F) * 0.004F;
		float f2 = (((float)(i >> 24 & 7L) + 0.5F) / 8.0F - 0.5F) * 0.004F;
		GlStateManager.func_179109_b(f, f1, f2);
		double d0 = entity.field_70142_S + (entity.field_70165_t - entity.field_70142_S) * (double)partialTicks;
		double d1 = entity.field_70137_T + (entity.field_70163_u - entity.field_70137_T) * (double)partialTicks;
		double d2 = entity.field_70136_U + (entity.field_70161_v - entity.field_70136_U) * (double)partialTicks;
		double d3 = 0.30000001192092896D;
		Vec3 vec3 = entity.func_70489_a(d0, d1, d2);
		float f3 = entity.field_70127_C + (entity.field_70125_A - entity.field_70127_C) * partialTicks;

		if (vec3 != null)
		{
			Vec3 vec31 = entity.func_70495_a(d0, d1, d2, d3);
			Vec3 vec32 = entity.func_70495_a(d0, d1, d2, -d3);

			if (vec31 == null)
			{
				vec31 = vec3;
			}

			if (vec32 == null)
			{
				vec32 = vec3;
			}

			x += vec3.field_72450_a - d0;
			y += (vec31.field_72448_b + vec32.field_72448_b) / 2.0D - d1;
			z += vec3.field_72449_c - d2;
			Vec3 vec33 = vec32.func_72441_c(-vec31.field_72450_a, -vec31.field_72448_b, -vec31.field_72449_c);

			if (vec33.func_72433_c() != 0.0D)
			{
				vec33 = vec33.func_72432_b();
				entityYaw = (float)(Math.atan2(vec33.field_72449_c, vec33.field_72450_a) * 180.0D / Math.PI);
				f3 = (float)(Math.atan(vec33.field_72448_b) * 73.0D);
			}
		}

		GlStateManager.func_179109_b((float)x, (float)y + 0.375F, (float)z);
		GlStateManager.func_179114_b(180.0F - entityYaw, 0.0F, 1.0F, 0.0F);
		GlStateManager.func_179114_b(-f3, 0.0F, 0.0F, 1.0F);
		float f5 = (float)entity.func_70496_j() - partialTicks;
		float f6 = entity.func_70491_i() - partialTicks;

		if (f6 < 0.0F)
		{
			f6 = 0.0F;
		}

		if (f5 > 0.0F)
		{
			GlStateManager.func_179114_b(MathHelper.func_76126_a(f5) * f5 * f6 / 10.0F * (float)entity.func_70493_k(), 1.0F, 0.0F, 0.0F);
		}
		int j = entity.func_94099_q();

		GlStateManager.func_179094_E();
		this.func_110776_a(TextureMap.field_110575_b);
		float f4 = 0.75F;
		GlStateManager.func_179152_a(f4, f4, f4);
		GlStateManager.func_179109_b(-0.5F, (float)(j - 8) / 16.0F, 0.5F);

		switch(entity.getRenderMethod())
		{
			case TESR:
				renderTESRModel(entity);
				break;
			case ISBRH:
			case VMC:
				renderBlockModel(entity, partialTicks);
				break;
			case CUSTOM:
				break;
			case COMBO:
				renderBlockModel(entity, partialTicks);
				renderTESRModel(entity);
				break;
		}

		GlStateManager.func_179121_F();
		GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
		this.func_180548_c(entity);

		GlStateManager.func_179152_a(-1.0F, -1.0F, 1.0F);
		this.field_77013_a.func_78088_a(entity, 0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F);
		GlStateManager.func_179121_F();
	}

	protected void renderTESRModel(EntityMinecartTEBase entity)
	{
		GlStateManager.func_179094_E();
		GlStateManager.func_179114_b(90F, 0F, 1F, 0F);
		TileEntityRendererDispatcher.field_147556_a.func_147549_a(entity.getTileEntity(), 0, 0, 0, 0.0F);
		GlStateManager.func_179091_B();
		GlStateManager.func_179121_F();
	}

	protected void renderBlockModel(EntityMinecartTEBase entity, float partialTicks)
	{
		GlStateManager.func_179094_E();
		IBlockState iblockstate = entity.func_174897_t();

		if (iblockstate.func_177230_c().func_149645_b() != -1)
		{
			this.func_180560_a(entity, partialTicks, iblockstate);
		}
		GlStateManager.func_179121_F();
	}
}

